Option Explicit
' State Handler
Class clsState
private tState,tSubState, tOldState

 public function ToString()
 dim s1, s2
  select case statemachine.State
   case RestState: s1 = "Rest": s2 = ""
   case BuyState: s1 = "Buy"
	select case statemachine.SubState
	 case buyFletch: s2 = "Fletching Supplies"
	 case buyAlchy: s2 = "Mage/Alchemy Supplies"
	 case else: s2 = Alternate_SubStateName
	end select
   case SellState: s1 = "Sell" : s2 = "Product"
   case NavState: s1 = "Navigate"
	select case statemachine.SubState
	 case navMerchant: s2 = "to Vendor"
	 case navArchmage: s2 = "to the Archmage"
	 case navRetreat: s2 = "to Retreat"
	 case navWorkPlace: s2 = "to Work Location"
	 case navFletcher: s2 = "to Fletcher"
	 case else: s2 = Alternate_SubStateName
	end select
   case MakeState: s1 = "Make" : s2 = "Product"
   case else: s1 = Alternate_StateName
			  s2 = AlternateSubStateName
  end select
  toString = s1 & " " & s2
'  ssay statemachine.State & ", " & statemachine.SubState
 end function

 public property get LastState()
  LastState = tOldState
 end property

 Public Property Let State(vn)
  tState = vn
  if tState>0 then tOldState = tState
 end property

 public Property Get State
  State = tState
 end Property
 
 Public Property Let SubState(vn)
  tSubState = vn
  NewState
 end property

 public Property Get SubState
  SubState = tSubState
 end Property
 
end Class

Public stateMachine

Public sub InitializeStateMachine()
 set stateMachine = new clsState
 
 set acfCheckMainPack = skApi.acfNew()
 acfCheckMainPack.szName = CraftItem
 acfCheckMainPack.olc = olcInventory

 set acfScanInv = skApi.acfNew()
 acfScanInv.olc = olcInventory

 set acfScanMerchant = skApi.acfNew()

 set acfEqp = skApi.acfNew()
 set acfEqp.acoWearer = MainPack

end sub

' Wait for the statemachine to indicate we are 'at rest'
public sub WaitForRest()
 'psay "Waiting for rest"
 do 
  skapi.waitevent 1500,wemfulltimeout
 loop until stateMachine.State = RestState or havetoabort
end sub

public sub NewState()
dim fn, path, obj, mpl

 if hndlr.havecommand then ProcessCommand

 psay statemachine.ToString
 select case stateMachine.State
  case RestState: Wait 0' empty the queue
  case BuyState:
    'psay "Buy State :" & statemachine.SubState
	select case statemachine.SubState
	 case buyFletch: 
					InitializeVending
					'BuyHeads
					BuyHeadsnTails
					UnInitializeVending
	 case buyAlchy:
					InitializeVending
					BuyArchmage
					UnInitializeVending
	 case buyProduce:
					ssay "Buy Produce"
					skapi.waitevent 500,wemFullTimeOut
     case else: Process_Alternate_NewState
	end select
  case SellState:
   select case statemachine.SubState
    case sellHeads:
					InitializeVending
					'Sell_Heads
					Sell_Spikes
					UnInitializeVending
	case sellSauce:
					InitializeVending
					Sell_Potion
					Buy_Kits
					UnInitializeVending
	 case else: Process_Alternate_NewState
   end select
  case NavState:
    select case stateMachine.subState
    case navMerchant:
		select case SellLocation
		 case sellArwic:fn = RouteToHarald
		 case sellRithwic: fn = RouteToLuthin
		 case else: Process_Alternate_NewState
		end select
		'LifeStoneRecall
		
		PrimaryPortalRecall
	case navArchMage: set obj = skApi.AcoFromSZ(RetreatPortal)
					  Obj.use()
					  skapi.waitevent 30000,wemSpecific,evidOnEndPortalSelf
					  fn = "ToMage.route"
					  set obj= nothing
    case navRetreat: 'fn = "ToRetreat.Route"
				   'if not (NoItemMagic) then
				    SecondaryPortalRecall
				    fn= "toMage.Route"
				   'end if
    case navWorkplace:
        fn = "Workplace.Route"
        ssay "Workcoords:" & WorkCoords
        set mpl = skapi.maplocfromsz(WorkCoords)
        if skapi.acochar.maploc.Dist2DToMaploc(mpl) * 240 > 50 then
		 select case WorkPlaceType
	 	  case wrkMansion: MansionRecall
		  case wrkHouse: HouseRecall
		  case wrkLifestone: LifestoneRecall
		  case wrkPrimaryPortal: PrimaryPortalRecall
		  case wrkSecondaryPortal: SecondaryPortalRecall
		  case wrkLifestoneTie: LifestoneTieRecall
		 end select
		end if
	case navDirect:
	  PrimaryPortalRecall
	  fn = "DirectToFletcher.route"
	case navFletcher:
		fn = RouteToTrothyd
	case navShopKeeper:
						'fn = "toHydeatha.route"
						fn = "toHealer1.Route"
						LifestoneRecall
    case else: fn = Process_Alternate_NewState
   end select
   
   pSay "Navigate with " & fn & "."
   path = skapi.szDirSkunkWorks & "\Libraries\" & fn
   psay "Path = " & path
   if not HaveToAbort then Call RouteFromFile(path).go()
  case MakeState:
				InitializeCrafting
				Makeitems
				UnIntializeCrafting
  case else: Process_Alternate_NewState
 end select
   'psay "selecting rest state"
   statemachine.State = RestState
end sub
