Option Explicit
' Pack Management routines
public function DetermineTotalSlotsFree()
dim maxpacks, p, i, a, slots
 
 maxpacks = skapi.cPack - 1

 slots = 0
 for i = 0 to maxpacks
  set a = skapi.AcoFromIpackIitem(i, iItemnil)
  slots = slots + slotsfree(a)
 next
 
DetermineTotalSlotsFree = Slots
end function

public function SlotsFree(aPack)
dim slotmax, slotused

	 slotmax = aPack.citemmax
	 if slotmax>0 then
      slotused = aPack.cItemContents
     else
      slotused = 0
     end if
     
     slotsfree = slotmax - slotused
     'ssay "Slots free = " & slotsfree & " " &  apack.szname
end function


Public Function LastPackWithSpace()
dim packs, sfree, a, ok

	packs = skapi.cpack - 1
	ok = false
	do
	 set a = skapi.AcoFromIpackIitem(packs, iItemnil)
     sfree = slotsfree(a)
     'ssay "pack " & packs & " has " & sfree & " Slots free. [" & a.oid & "]"
     ok = sfree > 0
     'ssay "ok = " & ok & ", " & packs
     if not(ok) then packs = packs - 1
	loop until packs = 0 or ok
	 'ssay "?>" & packs & " " & ok
	if not ok then set a = nothing

	 set LastPackWithSpace = a	 
end function

public sub DefragmentGold()
dim cPyr, c, i

 acfscaninv.reset
 acfScanInv.olc = olcInventory
 acfScanInv.szname = "Pyreal"
 acfScanInv.citemStackMax=9999
 set cPyr = acfScanInv.CoacoGet()
 InitHandlers
 for each c in cPyr
  	 set whiletimer = skapi.timernew()
	 Hndlr.expectedItem = c.szname

	 i = 0
	 c.MoveToPack 0
     do until Hndlr.moved or whiletimer.cmsec>2000
      Wait cEventWait
      if i>2 then
       c.MoveToPack 0
       i = 0
      else
       i = i +1
      end if
     loop 
 next 
 DeInitHandlers
end sub

' get the entire inventory (cAllInv)
' fill dUniqueNames with the names of each unique stackable item present
public sub DefragmentInventory()
dim cAllInv, dUniqueNames, dAcos, item, itemname, itemoid, tt
dim maxStack,CurrStack,whiletimer, i

 cmode = cmcBlue
 pSay "Defragmenting Inventory."

 InitHandlers
 set dUniqueNames = new myCollection

 'set acfScanInv = skApi.acfNew()
 acfscaninv.reset
 acfScanInv.olc = olcInventory
 acfScanInv.szname = ""
 set cAllInv = acfScanInv.CoacoGet()
 
 for each item in cAllInv
  maxStack = item.cItemMaxStack
  currStack = item.cItemStack
  if maxStack > currStack then
   itemname = item.szname
   itemoid = item.oid
   if dUniqueNames.exists(itemname) then
    set dAcos = dUniqueNames.item(itemname)
    dAcos.add itemoid,item
   else
    set dAcos = new myCollection
    dAcos.add itemoid,item
    dUniqueNames.add itemname,dAcos
   end if ' uniquename exists already
  else
   if item.acoContainer is Mainpack and not(item is mainpack) and ((item.oty and otyContainer) = 0) and ((item.oty and otyFoci) = 0) then
    set tt = LastPackWithSpace()
	if tt is nothing then
	 DeInitHandlers
	 exit sub
	end if
    if not havetoabort and not(item is MainPack) then
	 if AnnounceAllMoves then psay "Moving " & item.szname
	 set whiletimer = skapi.timernew()
	 Hndlr.expectedItem = item.szname
	 'item.movetocontainer(tt)
	 'ssay "tt.oid = " & tt.oid
	 i = 0
	 MovetoContainer item,tt, -1
     do until Hndlr.moved or whiletimer.cmsec>2000
      Wait cEventWait
      if i>2 then
       MovetoContainer item,tt, -1
       i = 0
      else
       i = i +1
      end if
     loop 
    end if '~havetoabort
   end if ' container is mainpack
  end if ' maxstack > currstack
 next
 
 'psay "Inventory has " & dUniqueNames.count & " uniquely named stackable items."
 if dUniqueNames.count=0 then exit sub
 
 tt = dUniqueNames.keys()

 for each item in tt
  set dAcos = dUniqueNames.item(item)
  Coallesce dAcos
 next
 
 DeInitHandlers 
' psay "Done Defragmenting"
end sub

function HighestPack(aCol)
dim p, a, t, hA, itms, tt, p1


	p = -1
	itms = aCol.items()
	set hA = nothing
	for each a in itms
	 
	 if hA is nothing then set hA = a
	 set p1 = a.acoContainer
	 if p1 is nothing then
	  t = -1
	  exit for
	 else
	  t =  a.acoContainer.iitem
	 end if
	 if t>p then
	   p = t
	   set hA = a
	 end if
	next
	
 Set HighestPack=hA
end function

public Sub Coallesce(aCol)
dim dest, a, maxStack, destCur, aCur, tt, x, itms, ii,t, whiletimer ,bEr, i

x = 0
bEr = false 
 do
  set dest = HighestPack(aCol)
  'ssay "dest.acocontainer.iitem=" & dest.acocontainer.iitem
 ' if (dest.acocontainer.iitem = 0) then exit sub
  maxStack = dest.cItemMaxStack
  if aCol.count=1 then
   if (dest.acoContainer is Mainpack) then
    set tt = LastPackWithSpace()
	if tt is nothing then exit sub
	
    Hndlr.expectedItem = dest.szname
	If AnnounceAllMoves then psay "Moving " & dest.szname & " to pack " & tt.iitem
	set whiletimer = skapi.timernew()
	'dest.movetocontainer(tt)
	i = 0
	MovetoContainer dest,tt,-1
    do 
     Wait cEventWait
     if i>2 then
      MovetoContainer dest,tt,-1
      i = 0
     else
      i = i + 1
     end if
    loop until Hndlr.moved or whiletimer.cmsec>2000
    aCol.remove dest.oid
   else
    aCol.remove dest.oid
   end if
  else
   'determine donor
   itms = aCol.Items
   'ssay "Count of itms = " & aCol.count
   for each a in itms
    if not(a is dest) then
	 ii= dest.iitem
     if dest.cItemStack + a.citemStack <= MaxStack then
		ii= dest.iitem

   if (dest.acoContainer is Mainpack) then
    set tt = LastPackWithSpace()
    if tt is nothing then exit sub
     	
    Hndlr.expectedItem = dest.szname
	If AnnounceAllMoves then psay "Moving " & dest.szname & " to pack " & tt.iitem
	set whiletimer = skapi.timernew()
	'dest.movetocontainer(tt)
	MovetoContainer dest,tt,-1
    do 
      Wait cEventWait
      if i>2 then
       MovetoContainer dest,tt, -1
       i = 0
      else
       i = i +1
      end if
    loop until Hndlr.moved or whiletimer.cmsec>2000
   end if

		hndlr.expecteditem = dest.szname
		if not QuietDefragment then psay "Merging stacks of " & dest.szPlural
		'ssay dest.citemStack & "+" & a.citemStack
		set whiletimer = skapi.timernew()

		MovetoContainer a,dest,ii
	    'if not(bEr) then a.movetocontainer dest.acoContainer, ii
        do 
         Wait cEventWait
		 if i>2 then
			MovetoContainer a,dest,ii
			i = 0
		 else
			i = i +1
		 end if
        loop until Hndlr.moved or whiletimer.cmsec>2000
		aCol.remove a.oid
		if dest.cItemStack = maxstack then aCol.remove dest.oid		
	 else
		t = maxstack - dest.cItemStack
		pSay "Splitting stack of " & a.cItemStack & " of" & a.szname & " into " & t
		skApi.SelectAco a

		SelectUIItem uiSplitTextBox
		skapi.pastesz t
		skapi.keys "{Return}"
		
		hndlr.expecteditem = dest.szname
		if not QuietDefragment then psay "Merging stacks of " & dest.szPlural
		set whiletimer = skapi.timernew()
		 MovetoContainer a,dest,ii
	     'a.movetocontainer dest.acoContainer, ii

        do
         Wait cEventWait
		 if i>2 then
			MovetoContainer a,dest,ii
			i = 0
		 else
			i = i +1
		 end if
        loop until Hndlr.moved or whiletimer.cmsec>2000
		aCol.remove dest.oid
	 end if

	 exit for
    end if
   next 
 end if
 loop until aCol.count = 0
end sub

' itm: aco of item to move
' dest: aco of stack to consolidate with
' idx: index into the containing pack
public sub MoveToContainer(Itm, Dest, idx)
dim cntnr, tDest

  set tDest = dest
  if itm is nothing then
   pSay "cannot move an undefinated aco! Aborting move."
   exit sub
  end if
  if dest is nothing then
    ssay "replacing undef dest with lastpack"
    set cntnr = LastPackWithSpace
  else
   if dest.fContainer then
    set cntnr = dest
   else
    'ssay "taking container of dest stack"
    set cntnr = tDest.acoContainer
   end if
  end if
  
  if cntnr is nothing then set cntnr = LastPackWithSpace
   
  if idx>-1 then 
   itm.MovetoContainer cntnr,idx
  else
   'ssay cntnr.oid
   if cntnr is nothing then exit sub
   if itm is nothing then exit sub
   itm.MovetoContainer cntnr
  end if
end sub

public function RealCash()
 RealCash = skapi.CitemOfKindInInv("Pyreal") 
end function