Option Explicit
' Handle specific events
Class subHandler
private tAct, tEndP, tCmd, bCmd, tAnimComplete, tFail, tMove, tExpected, tAdd, tVend
private vCoAco, tPause, fso, f, tiEi, tAco, tdWe, tEndFlag

 private sub Class_Initialize()
 dim s
  bCmd = false
  tAct = false
  tEndFlag = true ' start off TRUE to force a check of max end :)
  tCmd = ""
  tDwe = 0
  tPause = false
  if LogTells then
   set fso = createobject("Scripting.FileSystemObject")
   s = skApi.szDirSkunkworks & "\Libraries\PlatMakr\" & skapi.acochar.szname & "_tells.txt"
   set f = fso.opentextfile(s,8,true)
  end if
 end sub

private sub Class_Terminate()
 
 if LogTells then
  f.close
  set f= nothing
  set fso = nothing 
 end if
end sub

private sub WriteTell(szTxt)
 f.writeline szTxt
 
end sub

public function OnAssessItem(aco, fSuccess, ibi, iai, iwi, iei, ipi)
 set tiEi = iEi
 set tAco = aco
end function

public property get Aco()
 set Aco = tAco
end property

public property get IeI()
 set IeI = tiEi
 set tiEi = nothing
end property

 public function OnTell(acoSender, acoReceiver, szMsg)
 
  if logtells then   call WriteTell( now() & ":" & acoSender.szname & ":" & szmsg)
 
 end function


 public property get Pause()
  Pause = tPause
 end property
 
 public property let Pause(vn)
  tPause = vn
 end property

public function OnSpellAdd(spell)
 if spell.Family = familyEndurance then tEndFlag = true
end function

 Public Function OnSpellExpire(Spellid, Layer)
 dim sInf
  if Spellid = WatchSpell and Layer = 1 and statemachine.state = makeState then call RequestBuff
  
  set sInf = skapi.SpellInfoFromSpellid(SpellId)
  if sInf.Family = familyEndurance then tEndFlag = true
 end function

 Public Function OnActionComplete()
  'ssay "act complete"
  tAct = true
 end Function

 Public Function OnEndPortalSelf()
  tEndP = true
 End Function

public property get HaveCommand()
 HaveCommand  = bCmd
end property

public property get Command()
 Command = tCmd
 bCmd=false
 tCmd = ""
end property

public property let HaveCommand(vN)
 bCmd = vN
 tCmd = ""
end property

public function OnCommand(aCmd)
 tCmd = aCmd
 bCmd = true
end function

public property get EnduranceHasChanged()
 EnduranceHasChanged = tEndFlag
 tEndFlag = false
end property

public function OnChatServer(msg,cmc)
 if tAct = false then
  tFail = ( instr(msg, "fail") > 0 )
 end if
end function

Public function OnAnimationSelf(dwA, dwB, dwC, dwD, dwE)
 if showanims then sSay ">>" & dwa & ", " & dwb & ", " & dwc & ", " & dwd & ", " & dwe
 tdwE = dwE
 if dwE =  EndSpellCastAnimCode then
  tAnimComplete = true
  Call skApi.RemoveHandler(evidOnAnimationSelf, Hndlr)
 end if
End function

public function OnMoveItem(aco, container, iitem)
 tMove = (aco.szname = tExpected)
 'ssay "moved " & aco.szname
end function

public function OnAddToInventory(aco)
 ' ssay "added " & aco.szname
  tAdd = (aco.szname = tExpected)
end function

public function OnRemoveFromInventory(aco, container, iitem)
' ssay "removed " & aco.szname
end function

public function OnObjectDestroy(aco)
 'ssay "destroyed " & aco.szname
end function

public function OnAdjustStack(aco, oldsize)
  tMove = (aco.szname = tExpected)
  tAdd = (aco.szname = tExpected)
 ' ssay "adjusted " & aco.szname
end function

public function OnApproachVendor(acoMerchant, mcmBuy, cpyMaxBuy, fractBuy, fractSell, coaco)
 tVend=true
 set vCoAco = coaco
end function

public property get VendorItems()
 set VendorItems = vCoAco
end property

public property Let Expecteditem(vn)
 tExpected = vn
 tMove = false
 tAdd = false
end property

public property let HaveVendor(vn)
 tVend = vn
 set vCoAco = nothing
end property

public property get HaveVendor()
 HaveVendor = tVend
end property

public property let Added(vn)
 tAdd = vn
end property

public property get Added()
 Added = tAdd
 if tAdd then tExpected = ""
end property

public property let Moved(vn)
 tMove = vn
end property

public property get Moved()
 Moved = tMove
 if tMove then tExpected = ""
end property

public property get dwE()
 dwE = tdwE
end property

public property let Acted(vn)
 tAct = vn
 tFail = vn
end property

public property get Acted()
  Acted = tAct
end property

public property let Failed(vn)
 tFail = vn
end property

public property get Failed()
 Failed = tFail
end property

public property let EndPortal(vn)
 tEndP = vn
end property

public property get EndPortal()
 EndPortal = tEndP
end property

public property let SpellDone(vn)
 tAnimComplete = vn
end property

public property get SpellDone()
 SpellDone = tAnimComplete
end property
 
End Class

Public Hndlr

public sub InitHandlers()
 call skapi.addhandler(evidOnMoveItem, Hndlr)
' call skapi.addhandler(evidOnObjectDestroy, Hndlr)
 call skapi.addhandler(evidOnRemoveFromInventory, Hndlr)
 call skapi.addhandler(evidOnAddToInventory, Hndlr)
 call skapi.addhandler(evidOnAdjustStack, Hndlr)
 'if not(NoItemMagic) then call skApi.AddHandler(evidOnAnimationSelf, Hndlr)
 call skApi.AddHandler(evidOnAnimationSelf, Hndlr)
 wait 0
end sub

public sub DeInitHandlers()
 call skapi.removehandler(evidOnAddToInventory, Hndlr)
 Call skApi.RemoveHandler(evidOnRemoveFromInventory, Hndlr)
 Call skApi.RemoveHandler(evidOnAdjustStack, Hndlr)
 Call skApi.RemoveHandler(evidOnMoveItem, Hndlr)
 wait 0
end sub

Public Sub InitializeSubHandler()
 Set Hndlr = new subHandler
 call skApi.AddHandler(evidOnCommand, Hndlr)
 call skApi.AddHandler(evidOnTell, Hndlr)
 
End Sub

Public Sub UnInitializeSubHandler()
 Call skApi.RemoveHandler(evidOnCommand, Hndlr)
 Call skApi.RemoveHandler(evidOnTell, Hndlr)
 Set Hndlr = Nothing
End Sub

Public Sub LifeStoneFuckingRecall()
 pSay "Recalling to the Lifestone"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 Hndlr.EndPortal =false
 SetChatMode true
 ac.KeyPaste("@Lifestone")
 setchatmode false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal
 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Sub PrimaryPortalRecall()
 pSay "Casting Primary Portal Recall"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 
 do
  WaitForMana 50
 loop until cast(PrimaryRecall)>-1

 Hndlr.EndPortal=false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal 

 wait cEventWait
 if skapi.maplocCur.landblock = startlandblock then
  HaveToAbort = true
  psay "Destination Dungeon (Primary Portal Recall) is out of service, shutting down."
  exit sub
 end if
 setcombatmode false

 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Sub LifestoneTieRecall()
 pSay "Casting Lifestone Recall Spell"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 
 do
  WaitForMana 50
 loop until cast(LifestnTieRecall)>-1

 Hndlr.EndPortal=false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal 

 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Sub SecondaryPortalRecall()
 pSay "Casting Secondary Portal Recall"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 StartLandBlock = skapi.maplocCur.landblock
 
 do
  WaitForMana 50
 loop until cast(SecndryRecall)>-1

 Hndlr.EndPortal=false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal 

 wait cEventWait
 if skapi.maplocCur.landblock = startlandblock then
  HaveToAbort = true
  psay "Destination Dungeon (Secondary Portal Recall) is out of service, shutting down."
  exit sub
 end if
 setcombatmode false
 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Sub MansionRecall()
 pSay "Recalling to the Mansion"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 Hndlr.EndPortal =false
 SetChatMode true
 ac.KeyPaste("@House Mansion_Recall")
 setchatmode false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal 
 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Sub HouseRecall()
 pSay "Recalling to the House"
 Call skApi.AddHandler(evidOnEndPortalSelf, Hndlr)
 Hndlr.EndPortal =false
 SetChatMode true
 ac.KeyPaste("@House Recall")
 setchatmode false
 do
  Wait cEventWait
 loop until Hndlr.EndPortal 
 Call skApi.RemoveHandler(evidOnEndPortalSelf, Hndlr)
End Sub

Public Function ConfirmSpell()
dim cSpells, c, b

 if WatchSpell = -1 or BuffBotName = "" then
  b = true
  exit function ' nothing to check
 end if
 
 b = false 
 set cSpells = skApi.coSpell
 for each c in cSpells
  b = (c.spellid = WatchSpell) and (c.layer>0 and c.csecRemain>179)
  'if c.spellid = watchspell then ssay c.layer & " " & c.csecremain & ":" & b
  'if b then exit function
  if b then exit for
 next

 ConfirmSpell = b
End Function

Public Sub RequestBuff()
dim bot

	set bot = skApi.AcoFromSz(BuffBotname)
	if bot is nothing then
	 pSay "I cannot find " & BuffBotName & " Aborting request."
	 exit sub
	end if
	
	setchatmode true
	skapi.Pastesz "@tell " & buffbotname & ", " & BuffBotCommand
	skapi.keys "{return}"
end sub

public sub ProcessCommand()
 Process_Command hndlr.Command
end sub

public sub Process_Command(s)
dim  s1, s2, i, l, n, o

 if not(startingup) then pSay "Processing Command Input..."

 l = len(s)
 
 s1 = "": s2 = ""
 
 i = instr(s,"=")
 s1 = s
 if i>0 then
   s1 = left(s,i-1)
   s2 = right(s,l-i)
 end if
 
 i = instr(s," ")
 if i>0 then
    s1 = left(s,i-1)
    s2 = right(s,l-i)
 end if 

if dCommands.exists(s1) then
 select case s1
  case "stop":
   HaveToAbort = true
   pSay "Stopping..."
  case "batch":
   if isnumeric(s2) then
    n = cInt(s2)
    batchsize = n
    psay "Batch size now " & n
   else
    pSay s2 & " is not a valid number."
   end if
  case "announce":
   if isnumeric(s2) then
    n = cInt(s2)
    announcesize = n
    psay "Announce size is now " & n
   else
    pSay s2 & " is not a valid number."
   end if
  case "qty":
   if isnumeric(s2) then
    n = cInt(s2)

    StockLevel_Heads = n
    StockLevel_Quick = n
    'StockLevel_Colc  = n
    StockLevel_Aqua  = n 
	pSay "Stock levels are now:" & StockLevel_Heads & "/" & StockLevel_Quick & "/" & StockLevel_Colc & "/" & StockLevel_Aqua
   else
    pSay s & "|" & s2 & " is not a valid number."
   end if
  case "save":
   SaveOptions
  case "pause":
   if hndlr.Pause then
    psay "Already Paused!"
   else
    Hndlr.Pause=true
    PauseMode
   end if
  case "item":
   if isnumeric(s2) then
    n = cInt(s2)
    if n<0 or n>2 then
     pSay "Invalid Entry. (0,1 or 2)"
    else
     BuySelector = n
    end if
     o = BuyItem1
     if BuySelector=1 then
       o = BuyItem2
     elseif BuySelector=2 then
       o = BuyItem3
     end if
     psay "BuySelector is now " & o
   else
    pSay s2 & " is not a valid number."
   end if
  case "info":
   o = (timerunning.cmsec / 3600000)
   if o <1 then o = 1
   pSay "Made " & nowplats - startingplats & " " & BuyItem & ", " & show_time(timeRunning.cmsec) & " for " & ( nowplats - startingplats) / o & " per hour."
  case "resume":
  if hndlr.Pause then
   hndlr.Pause = false
   pSay "Disengaqing Pause Mode."
  else
   pSay "Not In Pause Mode!"
  end if
  case "delay":
   if isnumeric(s2) then
    n = cInt(s2)
    WaitForAction = n
    psay "WaitForAction delay is now " & n
   else
    pSay s2 & " is not a valid number."
   end if
  case "permit":
   if hndlr.pause then
    if isnumeric(s2) then
     n = cInt(s2)
     'process permit
    else
     pSay s2 & " is not a valid number."
    end if
   else
    pSay "Not In Pause Mode!"
   end if
  case "deny":
  if hndlr.Pause then
   ' process denial
  else
     pSay "Not In Pause Mode!"
  end if
  case "help":
    ShowHelp
 end select
else
   pSay "I'm sorry I don't understand |" & s & "|"
end if

end sub

public sub SaveOptions()
dim fso, tx, path, szname

 szname = skapi.szname
 path = skapi.szDirSkunkWorks & "\Libraries\PlatMakr\" & szname & ".txt"
 set fso = createobject("scripting.filesystemobject")
 set tx = fso.OpenTextFile(path,2,true)
  tx.writeline "batch=" & batchsize
  tx.writeline "announce=" & announcesize
  tx.writeline "qty=" & StockLevel_Heads
  tx.writeline "delay=" & WaitForAction
  tx.writeline "item=" & BuySelector
 tx.close
 set tx = nothing
 set fso = nothing
 
 psay "Options saved to " & path
 
end sub

sub ShowHelp
 dim fso, f, s
 
 s = skapi.szDirSkunkWorks & "\Libraries\PlatMakr\CommandHelp.txt"
 set fso = createobject("scripting.filesystemobject")
 ssay s
 set f = fso.OpenTextFile(s,ForReading,false)
 do 
  s = f.readline
  cMode = cmcGreen
  pSay s
 loop until f.atEndofStream
 f.close
 
 set f= nothing
 set fso = nothing
 
end sub


sub PauseMode()

 pSay "Engaging Pause Mode!"
do
 Wait cEventWait
 if hndlr.HaveCommand then ProcessCommand
loop until hndlr.Pause=false

end sub

public sub LoadOptions()
dim fso, tx, path, szname, s

 szname = skapi.szname
 path = skapi.szDirSkunkWorks & "\Libraries\PlatMakr\" & szname & ".txt"
 set fso = createobject("scripting.filesystemobject")
 
 if fso.fileexists(path) then
  psay "Found Saved Options, Loading " & path
  set tx = fso.OpenTextFile(path,1,true)
  do 
   s = tx.readline
   process_command s
  loop until tx.atEndofStream
 end if

 set tx = nothing
 set fso = nothing 

end sub

' get into combat mode
' and walk forward slightly
' the animation result code from walking in spellmode is the same as 
' from finishing a spell cast
sub CalibrateAnimationResults()
pSay "Calibrating Animation Values (if you have problems with spellcasts coming up DUD when they are not, restart the script)."

call skApi.AddHandler(evidOnAnimationSelf, Hndlr)

 setcombatmode true

 wait 500
 skapi.keys cmidWalkForward,kmoDown
 skapi.waitevent 1000, wemFullTimeout
 skapi.keys cmidWalkForward,kmoUp
 skapi.waitevent 500,wemfulltimeout
 
 EndSpellCastAnimCode = hndlr.dwE
 ssay "Anim value is " & EndSpellCastAnimCode
 
 setcombatmode false
call skApi.RemoveHandler(evidOnAnimationSelf, Hndlr)

end sub